/**
 * This is the app Id property, it will be generated by the server.
 *
 * @type {string}
 */
var appId = 202;

{
    var appIdOverride = localStorage.getItem("appID");
    if (appIdOverride) {
        appId = parseInt(appIdOverride);
    }
}

var appName = '';
var ENV = 'prod';

{
    var envOverride = localStorage.getItem("env");

    if (envOverride) {
        ENV = envOverride;
    }
}

var environments = {
    'int': {
        host: 'http://int.myapp.kaleobusiness.com',
        authHost: 'http://int.auth.kaleobusiness.com',
        socialHost: 'http://int.social.kaleobusiness.com',
        pushHostAPI: 'http://int.push.kaleobusiness.com/src/server.js',
		dataStore: 'http://ds.buildfire.com:88'
    },
    'dev': {
        host: 'http://dev.kaleo.com',
        authHost: 'http://int.auth.kaleobusiness.com',
        socialHost: 'http://int.social.kaleobusiness.com',
        pushHostAPI: 'http://int.push.kaleobusiness.com/src/server.js',
		dataStore: 'http://ds.buildfire.com:88',
        dataStore: 'http://ds.buildfire.com:88'
    },
    'uat': {
        host: 'http://uat.myapp.kaleobusiness.com',
        authHost: 'http://uat.auth.kaleobusiness.com',
        socialHost: 'http://uat.social.kaleobusiness.com',
        pushHostAPI: 'http://uat.push.kaleobusiness.com/src/server.js',
        dataStore: 'http://ds.buildfire.com:88'
    },
    'beta': {
        host: 'http://beta.myapp.buildfire.com',
        authHost: 'http://auth.kaleoapps.com',
        socialHost: 'http://social.kaleoapps.com',
        pushHostAPI: 'http://push.kaleoapps.com/src/server.js',
		dataStore: 'http://ds.buildfire.com'
    },
    'prod': {
        host: 'http://myapp.kaleoapps.com',
        authHost: 'http://auth.kaleoapps.com',
        socialHost: 'http://social.kaleoapps.com',
        pushHostAPI: 'http://push.kaleoapps.com/src/server.js',
		dataStore: 'http://ds.buildfire.com'
    }
};

try {
    if (typeof (device) != "undefined" && device.platform == 'web') {
        environments[ENV].host = '';
    }
}
catch (e) {
    alert('error: ' + JSON.stringify(e));
}
var host = environments[ENV].host;
var authHost = environments[ENV].authHost;
var socialHost = environments[ENV].socialHost;
var apiServer = environments[ENV].pushHostAPI;

var serverScripts = host + '/phone/scripts/';
var scriptsUrl = (localStorage.getItem('fsPath') || '/') + 'phone/scripts/';
var cssUrl = (localStorage.getItem('fsPath') || '/') + 'phone/css/';
var imgUrl = (localStorage.getItem('fsPath') || '/') + 'phone/images/';
var templatesUrl = (localStorage.getItem('fsPath') || '/') + 'phone/templates/';