var cookieManager = (function ($) {
    /*     Gets cookie's value
     *  @param  key  string  Cookie's name.
     *  @param  subKey string  Cookie's sub key.
     */
    var getCookie = function (key, subKey) {
        var value = $.cookie(key);
        if (value && subKey) {
            try {
                value = JSON.parse(value);
                value = value[subKey];
            }
            catch (e) {
                value = undefined;
            }
        }

        return value;
    };

    /*  Sets cookie's value
     *  @param  key string  Cookie's name.
     *  @param  value   string    Cookie's value. It can be either primitive types or object
     *  @param  expires int  Cookie's expiration in days.
     */
    var setCookie = function (key, value, expires) {
         
        if (value) {
            if (typeof (value) != "string") {
                value = JSON.stringify(value);
            }
        }
        $.cookie(key, value, { expires: expires, path: '/' });
    };

    return {
        getCookie: getCookie,
        setCookie: setCookie
    };
})($);