var identityManager = (function (encryptionManager) {
    var COOKIE_KEY_NAME = 'userData';

    ///<summary>Authenticates user</summary>
    ///<param name="username" type="String">username</param>
    ///<param name="password" type="String">password</param>
    ///<param name="callback" type="function">a callback to call when authentication is successful</param>
    ///<returns type="Deferred">JQuery Deferred</returns> 
    var authenticate = function (username, password, callback) {
        var data = { username: username, password: password };
        $.ajax({
            url: host + '/api/' + 'user/authentication.json.query',
            dataType: "json",
            data: data,
            cache: false, //disable caching so IE does not cache get requests
            beforeSend: function () {
                $('#divLoading').show();
            },
            error: function (jqXHR, textStatus, errorThrown) {
                //show invalid username or password
                $('.errorMessage').text('invalid email or password');
                $('#divLoading').hide();
            },
            success: function (data, textStatus, jqXHR) {
                if (data) {
                    saveUserData(data);
                    window.location = 'apps.html';
                }
                else {
                    //show invalid username or password
                    $('.errorMessage').text('invalid email or password');
                }
                $('#divLoading').hide();
            },
            complete: function (jqXHR) {

            }
        });
    };

    var saveUserData = function (data) {
    };

    var getUserData = function () {
        return localStorage.getItem(COOKIE_KEY_NAME);
    };

    return {
        authenticate: authenticate,
        getUserData: getUserData
    };
})(encryptionManager);