﻿var carouselPhone = (function () {
    var defaultOptions = {
        autoPlay: 3000,
        items: 1,
        lazyLoad: true,
        itemsScaleUp: true,
        rewindSpeed: 500
    };

    /**
     * Start the carousel, this method initializes the control.
     */
    var start = function (options) {
        options = $.extend({}, defaultOptions, options);
        $(options.containerSelector + ':first').owlCarousel(options);
    };

    /**
     * Restart the carousel, this method re-initializes the carousel.
     * Call when the images are updated.
     */
    var restart = function (options) {
        options = $.extend({}, defaultOptions, options);
        var owl = $(options.containerSelector + ':first').data('owlCarousel');
        
        // If started, reinit
        if (owl) {
            owl.reinit(options);
        }
        // Start
        else {
            start(options);
        }
    }

    // Expose
    return {
        start: start,
        restart: restart
    };
})($);