﻿
require(['knockout', 'WidgetManager', 'LocalModel'], function (ko, widgetManager, model) {
    var adsWidth = 320, adsHeight = 50;

    var appModel = model.appModel();

    if (!appModel) { console.log('app is null'); return; }

    //check if the ads enabled to run
    if (!appModel.AdsListing || !appModel.AdsListing.Enabled || !appModel.AdsListing.Units || appModel.AdsListing.Units.length <= 0) {
        console.log('googleAds disabled');
        return;
    }

    //add google ads script in the head
    var s = document.createElement("script");
    s.type = "text/javascript";
    s.innerHTML = "var googletag = googletag || {};" +
        "googletag.cmd = googletag.cmd || [];" +
        "(function () {" +
        "var gads = document.createElement('script');" +
        "gads.async = true;" +
        "gads.type = 'text/javascript';" +
        "var useSSL = 'https:' == document.location.protocol;" +
        "gads.src = (useSSL ? 'https:' : 'http:') +" +
        "'//www.googletagservices.com/tag/js/gpt.js';" +
        "var node = document.getElementsByTagName('script')[0];" +
        "node.parentNode.insertBefore(gads, node);" +
        "})();";
    $("head").append(s);

    var $template = $('<div class="appGoogleAds"><span class="closeErrorMessage">X</span></div>');
    $('body').append($template);
    $template.hide();

    $template.find('.closeErrorMessage').click(function () {
        enableTimer();
        $template.hide();
    });

    var currentAdsIndex = 0;

    //not view the ads on home, places and audio widget
    var allowToViewAds = function () {
        var allowToView = true;
        var item = $('#template[data-template=home]');
        if (item.length > 0)
            allowToView = false;
        else {
            item = $('#template[data-template=places]');
            if (item.length > 0)
                allowToView = false;
            else {
                item = $('#template[data-template=socialwall]');
                if (item.length > 0)
                    allowToView = false;
            }
        }
        return allowToView;
    };

    var loadAdsAccount = function () {
        $template.hide();
        $template.find('iframe').remove();
        $template.find('div').remove();

        if (!allowToViewAds())
            return;

        var currentAd = null;

        if (currentAdsIndex >= appModel.AdsListing.Units.length)
            currentAdsIndex = 0;

        currentAd = appModel.AdsListing.Units[currentAdsIndex];

        if (currentAd) {
            console.log('runngin googleAds, unit: ' + JSON.stringify(currentAd));

            var adControlId = 'divAppGoogleAds' + currentAdsIndex.toString();
            $template[0].id = adControlId;

            console.log('current ads control Id: ' + adControlId);

            //add current Ad to googletag
            googletag.cmd.push(function () {
                googletag.defineSlot('/' + currentAd.NetworkNumber + '/' + currentAd.Name + '', [adsWidth, adsHeight], adControlId)
                    .addService(googletag.pubads());
                googletag.pubads().enableSingleRequest();
                googletag.enableServices();
            });

            googletag.cmd.push(function () {
                googletag.display(adControlId);
                disableTimer();
            });
        }
        currentAdsIndex++;
    };

    var changeTheTarget = function () {
        $template.find('iframe').each(function () {
            $(this).contents().find('a').attr('target', "_blank");
        });
    }

    //override the log function
    googletag.cmd.push(function () {
        var old_log = googletag.debug_log.log;
        googletag.debug_log.log = function (level, message, service, slot, reference) {
            if (message.getMessageId() == 6) {
                //Completed rendering ad for slot
                changeTheTarget();
            }
            return old_log.apply(this, arguments);
        };
    });

    var createTrigger = function () {
        widgetManager.subscribe('LoadWidgetWithModel', function (widgetTemplate) {
            console.log('widgetManager =>LoadWidgetWithModel event handler');
            disableTimer();
            loadAdsAccount();
        });
    }

    var timer = null;
    var enableTimer = function () {
        timer = setInterval(loadAdsAccount, appModel.AdsListing.Duration * 1000);
    };

    var disableTimer = function () {
        if (timer)
            clearInterval(timer);
    }

    createTrigger();
});