// Remove loading image for legacy bundles
setTimeout(function () { $('#loading:first').hide(); }, 1000);

// XXX Condition to support LEGACY bundles
if (!window.scriptsUrl) {
    window.scriptsUrl = window.jsUrl;
}

/**
 * Configuring the requireJS module
 */
require.config({
    waitSeconds: 60,
    baseUrl: window.scriptsUrl,
    paths: { // case sensitive!!!! when cached on device
        jquery: 'jquery',
        knockout: 'knockout',
        komapping: 'knockout.mapping',
        kcomm: 'kcomm',
        DataFetcher: 'DataFetcher',
        LocalModel: 'localModel',
        RestClient: 'RestClient',
        RestStatusCode: 'RestStatusCode',
        TemplateLoader: 'TemplateLoader',
        TemplatesHelper: 'TemplatesHelper',
        utility: 'utility',
        WidgetManager: 'WidgetManager',
        fastclick: 'fastclick',
        DataCacheManager: 'DataCacheManager',
        DesignMode: 'designMode',
        jqueryCookie: 'jquery.cookie',
        maps: 'maps',
        kPush: 'kPush',
        kAPI: 'kAPI',
        xml2json: 'xml2json.min',
        carousel: 'owl.carousel.min',
        carouselHelper: 'carouselHelper',
        kauthSDK: authHost + '/website/scripts/framework/kauthSDK'
    },
    shim: {
        "komapping": {
            deps: ["knockout"],
            exports: "komapping"
        },
        "utility": {
            exports: "utility"
        },
        "kcomm": ["utility"],
        "maps": {
            exports: "maps"
        },
        "kAPI": {
            exports: "kAPI"
        },
        "kPush": {
            deps: ["kAPI"],
            exports: "kPush"
        },
        "LocalModel": ["TemplatesHelper"],
        "DataFetcher": ["TemplatesHelper", "DataCacheManager"],
        "xml2json": {
            exports: "xml2json"
        },
        "carousel": {
            deps: ["jquery"],
            exports: "carousel"
        },
        "carouselHelper": {
            deps: ["carousel", "jquery"],
            exports: "carouselHelper"
        },
        "jquery": {
            exports: "jquery"
        },
        "jqueryCookie": {
            deps: ["jquery"],
            exports: "jqueryCookie"
        },
        "kauthSDK": {
            deps: ["jqueryCookie"],
            exports: "kauthSDK"
        }
    }
});

// XXX Commected out since we now check for connectivity in the bootstrapper
// If not connected, let the user know
//if (navigator.connection.type == Connection.NONE) {
//    navigator.notification.alert("You're device is offline, please connect", null, "Offline", "OK");
//}

if (window.location.search == '?designMode=true') {
    window.designMode = true;
}
    // Preview Mode, add a previewMode property to the window
    // this will be picked up in the DataFetcher to use
    // Draft App Data instead of Live App Data
else if (window.location.search == '?preview=true') {
    window.previewMode = true;
}

require(['WidgetManager', 'TemplatesHelper', 'DataFetcher', 'knockout', 'komapping', 'jquery', 'LocalModel',
    'utility', 'RestClient', 'RestStatusCode', 'TemplateLoader', 'maps', 'kAPI', 'kPush', 'fastclick',
    'xml2json', 'carousel', 'carouselHelper', 'jqueryCookie', 'kauthSDK'],
function (widman, thelper, data, ko, kom, $, model, utility, rest, restStatusCode, loader, maps, kAPI, kPush) {
    // Load the app Id from the cookie value if in design or preview modes
    if (window.designMode || window.previewMode) {
        // Override app id from app cookie
        var appCookieValue = $.cookie("app");

        if (appCookieValue) {
            appId = appCookieValue;
        }
    }

    // Override Anchors to use window.open so that links will cause the InAppBrowser to be used
    // instead of opening in the app's WebView
    $(document)
        .on('click', 'a[href^=http], a[href^=https]',
       function (e) {
            e.preventDefault();
            var $this = $(this);
            var target = $this.data('inAppBrowser') || '_blank';
            window.open($this.attr('href'), target, 'location = no');
        });

    // Set the AJAX call timeout to 30 seconds
    $.ajaxSetup({ timeout: 30000 });

    // Load kSocial scripts in a delayed manner
    setTimeout(function () {
        thelper.addScript(socialHost + "/website/scripts/kSocialSDK.js");
    }, 300);

    // load google Ads script
    setTimeout(function () {
        thelper.addScript(window.scriptsUrl + 'googleAds.js');
    }, 500);

    // Load the Google API scripts
    setTimeout(function () {
        thelper.addScript(window.scriptsUrl + "infobubble-compiled.js");
    }, 500);

    // Fetch the appearance for the application
    data.get(0, thelper.TEMPLATE_KEYS.home, function (content) {
        var jsonObject = JSON.parse(content);
        data.getAppearance(jsonObject.AppearanceId, function (appearance) {
            // Injects the core stylesheets into the home page, done only once.
            // The css will be downloaded in live mode only
            var promise = thelper.getResourceURI('coreCss', thelper.TEMPLATE_KEYS.core);
            promise.done(function (cssResource) {
                if (cssResource !== undefined) {
                    for (var i = 0; i < cssResource.length; i++) {
                        // The id should not contain '/', '.', '%20', '-' and no ':'
                        // so we'll look for the first / and trim from there on
                        var id = cssResource[i];
                        id = id.substring(id.indexOf("/"));
                        id = id.replace(/\//g, "_").replace(/\./g, "_").replace(/\s/g, "_").replace(/%20/g, "_").replace(/-/g, "_");

                        thelper.addStyleTag(id);
                        var $style = $("#" + id);

                        thelper.getResourceInText(cssResource[i], function (data) {
                            data = data.replace(/_var_url/gi, window.host);

                            if (data.indexOf("@Theme_") >= 0) {
                                data = thelper.applyTheme(data, appearance);
                            }

                            $style.append(data);
                        });
                    }
                }
            });
        });
    });

    // If the application is being run in design mode, load the support module
    if (window.designMode) {
        require(['DesignMode']);
        return;
    }

    // Load the home widget    
    widman.show(0, thelper.TEMPLATE_KEYS.home);
});

function onDeviceReady() {
    if (parseFloat(window.device.version) === 7.0 && window.device.model != "iPhone3,3" && window.device.model != "iPhone3,1") {
        document.body.style.marginTop = "20px";
    }
}

document.addEventListener('deviceready', onDeviceReady, false);