﻿// Request the home page to be displayed
var _requestHomePage = function () {
    // Always reset the ignore the next app message toggle when
    // requesting the home page deliberately
    require(['DesignMode'], function (design) {
        design.resetIgnoreNextAppMessageToggle();
    });

    var message = '{"Instruction":{"Action":"Home"}}';
    kcomm.sendMessage(message, parent.window);
};

/**
 * Handle home button click on the menu bar.
 */
function goHome() {
    currentPage = 0;
    _requestHomePage();
}

$(function () {
    // Hide the menu
    document.getElementById("menu").classList.remove("slideMenuOpen");

    // Override the back button on all widget screens
    $("#back").off("click");
    $("#back").click(function () {
        // In case of multi-page widgets, the widget JS file should contain
        // a previousPage function to navigate to the previous page
        // based on a global parameter currentPage
        if (window.currentPage === undefined || window.currentPage <= 0) {
            require(['WidgetManager'], function (manager) {
                var item = manager.historyPreviousItem();

                // Navigate back
                if (item && item.id !== 0) {
                    manager.navigateBack();
                }
                // Go to home oage if this is the last page
                else {
                    _requestHomePage();
                }
            });
        } else {
            // This method should be implemented in the scripts that have multiple pages
            previousPage();
        }
    });

    // The home button on the groups page
    $("#home").off("click");
    $("#home").click(function () {
        _requestHomePage();
    });

    // Over the menu's go home button to trigger an action home
    // instruction to the site
    $("#menuHome").off("click");
    $("#menuHome").click(function () {
        _requestHomePage();
    });

    require(['WidgetManager'], function (manager) {
        $(document).off('click', '#menu ul li');
        $(document).on('click', '#menu ul li', function (event) {
            var $this = $(this);
            var widgetId = $this.attr('data-id');
            var widgetType = $this.attr('data-type');

            // User chose to show the media player
            if ($this.attr('id') == 'menuMediaPlayer') {
                kMedia.show();
            }
                //logOff button
            else if ($this.attr('id') == 'kauthLogOff') {
                $('#kauthLogOff').hide();
                if (kauthSDK && kauthSDK.authManager != null && kauthSDK.authManager.logout != null) {
                    kauthSDK.authManager.logout();
                }
            }
                // User chose another widget
            else {
                // Remove the current shown template
                // this is needed for the case where the user re-shows the currently
                // selected template
                $("#content").empty();

                // Load with model
                if (widgetId != undefined && widgetType != undefined) {
                    ignoreNextAppMessageToggle = true;
                    var message = '{"Instruction":{"Action":"' + widgetType + '", "Data":{"Id":"' + widgetId + '"}}}';

                    // Inform the content editor
                    kcomm.sendMessage(message, parent.window);

                    setTimeout(function () {
                        manager.show(widgetId, widgetType.toLowerCase());
                    }, 1000);
                }
                    // Load without model
                else if (widgetId == undefined && widgetType != undefined) {
                    manager.showWithoutModel(widgetType.toLowerCase());
                } else if (widgetId == 'menuShare' && appModel.IsSharingEnabled) {
                    //TODO::call the share plugin function
                }

                // Reset the page number to zero
                currentPage = 0;

                // Hide the media player if open, the user can trigger widgets from the menu
                // while the media player is shown
                if (document.getElementById('mediaPlayer').classList.contains('mediaPlayerFadeIn')) {
                    kMedia.hide();
                }
            }

            // Hide the menu
            hideMenu();
        });
    });

    console.log("Design mode overrides registered!");
});